#include <iostream>

using namespace std;

int main() {
	int n, k, p, j, koe;
	j=koe=0;
	cin >> n >> k;
	int pomm[n];
	for(int i = 0;i<n;i++)
	{
		cin >> p;
		pomm[i] = p;
	}
	int pom[2*n+1];
	int kon[n/k+1];
	for(int i = 0;i<n*2+1;i++)
	{
		pom[i]=kon[i]=0;
	}
	
	for(int i = 0;i<n;i++)
	{
		pom[pomm[i]+n]++;
		if(pom[pomm[i]+n]==k)
		{
			if(pomm[i]==0)
			{
				kon[j]=n+10;
				j++;
				koe++;
			}
			else
			{
				kon[j] = pomm[i];
				j++;
				koe++;
			}
		}	
	}
	cout<<koe<<endl;
	for(int i = 0;i<(n/k+1);i++)
	{
		if(kon[i]!=0)
		{
			if(kon[i]==(n+10))
			{
				cout<<"0";
			}
			else
			{
				cout<<kon[i]<< " ";
			}
		}
	}
	
	return 0;
}